diff -uwr sourceold/scripts/z_joipa.cpp source/scripts/z_joipa.cpp
--- sourceold/scripts/z_joipa.cpp	2011-10-11 23:13:50.153320300 +0800
+++ source/scripts/z_joipa.cpp	2012-04-28 01:57:12.354492100 +0800
@@ -100,7 +100,7 @@
 	{
 		if (param == 1)
 		{
-			if (Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+			if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 			{
 				Commands->Start_Timer(obj,this,5.0f,100);
 				Commands->Start_Timer(obj,this,10.0f,101);
@@ -219,7 +219,7 @@
 	{
 		if (param == 1)
 		{
-			if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+			if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 			{
 				Commands->Start_Timer(obj,this,5.0f,101);//building
 				Commands->Start_Timer(obj,this,36.0f,102);//update
@@ -237,7 +237,7 @@
 {
 	if (number == 101)
 	{
-		if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 		{
 			Commands->Create_2D_WAV_Sound("building.wav");
 			Send_Message(255,255,255,"Building of the GDI Power Plant has commenced.");
@@ -250,7 +250,7 @@
 	}
 	else if (number == 102)
 	{
-		if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 		{
 			Commands->Create_2D_WAV_Sound("updatecomplete.wav");
 			Send_Message(255,255,255,"Update on the GDI Power Plant has been completed.");
@@ -263,9 +263,11 @@
 	}
 	else if (number == 103)
 	{
-		if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
+		{
+			GameObject *pp = Find_Building_By_Type(1,BuildingConstants::TYPE_POWER_PLANT);
+			if (pp)
 		{
-			GameObject *pp = Find_Building(1,BuildingConstants::TYPE_POWER_PLANT);
 			Commands->Create_2D_WAV_Sound("gdipponline.wav");
 			Send_Message(255,255,255,"GDI Base Power is Online.");
 			Restore_Building(pp);
@@ -273,6 +275,7 @@
 			Power_Base(1,true);
 			Commands->Set_Building_Power(pp,true);
 		}
+		}
 		else
 		{
 			Commands->Create_2D_WAV_Sound("cancelled.wav");
@@ -287,7 +290,7 @@
 	{
 		if (param == 1)
 		{
-			if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+			if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 			{
 				Commands->Start_Timer(obj,this,6.0f,101);//building
 				Commands->Start_Timer(obj,this,36.0f,102);//update
@@ -305,7 +308,7 @@
 {
 	if (number == 101)
 	{
-		if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 		{
 			Commands->Create_2D_WAV_Sound("building.wav");
 			Send_Message(255,255,255,"Building of the GDI Weapons Factory has commenced.");
@@ -318,7 +321,7 @@
 	}
 	else if (number == 102)
 	{
-		if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 		{
 			Commands->Create_2D_WAV_Sound("updatecomplete.wav");
 			Send_Message(255,255,255,"Update on the GDI Weapons Factory has been completed.");
@@ -331,9 +334,11 @@
 	}
 	else if (number == 103)
 	{
-		if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
+		{
+			GameObject *wf = Find_Building_By_Type(1,BuildingConstants::TYPE_VEHICLE_FACTORY);
+			if (wf)
 		{
-			GameObject *wf = Find_Building(1,BuildingConstants::TYPE_VEHICLE_FACTORY);
 			Commands->Create_2D_WAV_Sound("newconstroptions.wav");
 			Send_Message(255,255,255,"New construction options. GDI Weapons Factory is online.");
 			Restore_Building(wf);
@@ -348,6 +353,7 @@
 				Commands->Set_Building_Power(wf,false);
 			}
 		}
+		}
 		else
 		{
 			Commands->Create_2D_WAV_Sound("cancelled.wav");
@@ -362,7 +368,7 @@
 	{
 		if (param == 1)
 		{
-			if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+			if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 			{
 				Commands->Start_Timer(obj,this,6.0f,101);//building
 				Commands->Start_Timer(obj,this,36.0f,102);//update
@@ -380,7 +386,7 @@
 {
 	if (number == 101)
 	{
-		if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 		{
 			Commands->Create_2D_WAV_Sound("building.wav");
 			Send_Message(255,255,255,"Building of the GDI Tiberium Refinery has commenced.");
@@ -393,7 +399,7 @@
 	}
 	else if (number == 102)
 	{
-		if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
 		{
 			Commands->Create_2D_WAV_Sound("updatecomplete.wav");
 			Send_Message(255,255,255,"Update on the GDI Tiberium Refinery has been completed.");
@@ -406,9 +412,11 @@
 	}
 	else if (number == 103)
 	{
-		if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_CONYARD)))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD) && !Is_Building_Dead(Find_Building_By_Type(1,BuildingConstants::TYPE_CONYARD)))
+		{
+			GameObject *refinery = Find_Building_By_Type(1,BuildingConstants::TYPE_REFINERY);
+			if (refinery)
 		{
-			GameObject *refinery = Find_Building(1,BuildingConstants::TYPE_REFINERY);
 			Commands->Create_2D_WAV_Sound("gdirefonline.wav");
 			Send_Message(255,255,255,"Primary pressing center operating at optimal efficiency. GDI Tiberium Refinery is online.");
 			Restore_Building(refinery);
@@ -422,6 +430,7 @@
 				Commands->Set_Building_Power(refinery,false);
 			}
 		}
+		}
 		else
 		{
 			Commands->Create_2D_WAV_Sound("cancelled.wav");
Only in source/scripts: z_mediterranean.cpp
Only in source/scripts: z_mediterranean.h
Only in source/scripts: z_misc.cpp
Only in source/scripts: z_misc.h
diff -uwr sourceold/scripts/z_nod_invasion.cpp source/scripts/z_nod_invasion.cpp
--- sourceold/scripts/z_nod_invasion.cpp	2011-10-11 23:14:27.805664000 +0800
+++ source/scripts/z_nod_invasion.cpp	2012-04-14 04:09:46.894531200 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Copyright 2011 Tiberian Technologies
+	Copyright 2012 UltraAOW.COM
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr sourceold/scripts/z_nod_invasion.h source/scripts/z_nod_invasion.h
--- sourceold/scripts/z_nod_invasion.h	2011-10-14 22:27:31.970703100 +0800
+++ source/scripts/z_nod_invasion.h	2012-04-14 04:09:47.353515600 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Copyright 2011 Tiberian Technologies
+	Copyright 2012 UltraAOW.COM
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -9,55 +9,124 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+
+
 #pragma once
 
-class z_ninv_MissionStart : public ScriptImpClass {
+class z_Poke_Play_Cinematic : public ScriptImpClass {
 	void Created(GameObject *obj);
+	void Poked(GameObject *obj, GameObject *poker);
 	void Timer_Expired(GameObject *obj, int number);
-	bool play;
+	public: void Register_Auto_Save_Variables();
+	bool allowpoke;
 };
 
-class z_ninv_Civilian : public ScriptImpClass {
-	void Killed(GameObject *obj, GameObject *shooter);
+class z_Invasion_Hostage : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Poked(GameObject *obj, GameObject *poker);
+	void Timer_Expired(GameObject *obj, int number);
+	void Destroyed(GameObject *obj);
+	void Damaged(GameObject *obj, GameObject *damager, float damage);
+	public: void Register_Auto_Save_Variables();
+	bool playpoke;
+	bool playpain;
+	const char *hostyname;
+	const char *hostypokesound;
+	int FollowID;
 };
 
-class z_ninv_CivCount : public ScriptImpClass {
+class z_Invasion_Hostage_Count : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj, int message, int param, GameObject *sender);
 	void Timer_Expired(GameObject *obj, int number);
 	public: void Register_Auto_Save_Variables();
-	int alive;
+	int deaths;
+};
+
+class z_Invasion_Bot_Counter : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj, int message, int param, GameObject *sender);
+	void Timer_Expired(GameObject *obj, int number);
+	public: void Register_Auto_Save_Variables();
+	int botcount;
+	bool endgame;
+};
+
+class z_Invasion_Enemy : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Destroyed(GameObject *obj);
+};
+
+class z_Invasion_Drop_Harvester : public ScriptImpClass {
+	void Killed(GameObject *obj, GameObject *shooter);
+};
+
+class z_Invasion_Loop_Badgerdrop : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj, int number);
+	public: void Register_Auto_Save_Variables();
+	int count;
+};
+
+class z_Invasion_Drop_Hummvee1 : public ScriptImpClass {
+	void Killed(GameObject *obj, GameObject *shooter);
 };
 
-class z_ninv_Buy_SamsiteSW : public ScriptImpClass {
+class z_Invasion_Drop_Hummvee2 : public ScriptImpClass {
+	void Killed(GameObject *obj, GameObject *shooter);
+};
+
+class z_Invasion_Loop_Chinooks_GDIBase : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj, int number);
+	public: void Register_Auto_Save_Variables();
+	int count;
+};
+
+class z_Invasion_Buy_Guntower_North : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Poked(GameObject *obj, GameObject *poker);
 	void Timer_Expired(GameObject *obj, int number);
 	public: void Register_Auto_Save_Variables();
 	float funds;
+	float totalcost;
+	Vector3 pos;
+	Vector3 pos2;
+	bool allowpoke;
 };
 
-class z_ninv_Buy_SamsiteNE : public ScriptImpClass {
+class z_Invasion_Buy_Guntower_West : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Poked(GameObject *obj, GameObject *poker);
 	void Timer_Expired(GameObject *obj, int number);
 	public: void Register_Auto_Save_Variables();
 	float funds;
+	float totalcost;
+	Vector3 pos;
+	Vector3 pos2;
+	bool allowpoke;
 };
 
-class z_ninv_Buy_GuardtowerNE : public ScriptImpClass {
+class z_Invasion_Buy_Guntower_South : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Poked(GameObject *obj, GameObject *poker);
 	void Timer_Expired(GameObject *obj, int number);
 	public: void Register_Auto_Save_Variables();
 	float funds;
+	float totalcost;
+	Vector3 pos;
+	Vector3 pos2;
+	bool allowpoke;
 };
 
-class z_ninv_Buy_GuardtowerSW : public ScriptImpClass {
+class z_Invasion_Buy_Guntower_East : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Poked(GameObject *obj, GameObject *poker);
 	void Timer_Expired(GameObject *obj, int number);
 	public: void Register_Auto_Save_Variables();
 	float funds;
+	float totalcost;
+	Vector3 pos;
+	Vector3 pos2;
+	bool allowpoke;
 };
-
Only in source/scripts: z_prototype.cpp
Only in source/scripts: z_prototype.h
diff -uwr sourceold/scripts/z_siege.cpp source/scripts/z_siege.cpp
--- sourceold/scripts/z_siege.cpp	2011-10-11 23:13:42.152343700 +0800
+++ source/scripts/z_siege.cpp	2012-04-28 01:56:47.412109300 +0800
@@ -86,14 +86,14 @@
 {
 	if (Commands->Is_A_Star(enter))
 	{
-		if (Commands->Get_Health(Find_Building(0,BuildingConstants::TYPE_SOLDIER_FACTORY)) >= 1.0f)//only enable if bar is alive
+		if (Find_Building_By_Type(0,BuildingConstants::TYPE_SOLDIER_FACTORY) && Commands->Get_Health(Find_Building_By_Type(0,BuildingConstants::TYPE_SOLDIER_FACTORY)) >= 1.0f)//only enable if bar is alive
 		{
 			Commands->Enable_Spawner(100732,true);
 			Commands->Enable_Spawner(100732,true);
 			Commands->Enable_Spawner(100732,true);
 			Commands->Enable_Spawner(100732,true);
 		}
-		if (Commands->Get_Health(Find_Building(0,BuildingConstants::TYPE_VEHICLE_FACTORY)) >= 1.0f)//only enable if wf is alive
+		if (Find_Building_By_Type(0,BuildingConstants::TYPE_VEHICLE_FACTORY) && Commands->Get_Health(Find_Building_By_Type(0,BuildingConstants::TYPE_VEHICLE_FACTORY)) >= 1.0f)//only enable if wf is alive
 		{
 			Commands->Enable_Spawner(100732,true);
 			Commands->Enable_Spawner(100732,true);
@@ -108,14 +108,14 @@
 {
 	if (Commands->Is_A_Star(enter))
 	{
-		if (Commands->Get_Health(Find_Building(0,BuildingConstants::TYPE_SOLDIER_FACTORY)) >= 1.0f)//only enable if bar is alive
+		if (Find_Building_By_Type(0,BuildingConstants::TYPE_SOLDIER_FACTORY) && Commands->Get_Health(Find_Building_By_Type(0,BuildingConstants::TYPE_SOLDIER_FACTORY)) >= 1.0f)//only enable if bar is alive
 		{
 			Commands->Enable_Spawner(100732,true);
 			Commands->Enable_Spawner(100732,true);
 			Commands->Enable_Spawner(100732,true);
 			Commands->Enable_Spawner(100732,true);
 		}
-		if (Commands->Get_Health(Find_Building(0,BuildingConstants::TYPE_VEHICLE_FACTORY)) >= 1.0f)//only enable if wf is alive
+		if (Find_Building_By_Type(0,BuildingConstants::TYPE_VEHICLE_FACTORY) && Commands->Get_Health(Find_Building_By_Type(0,BuildingConstants::TYPE_VEHICLE_FACTORY)) >= 1.0f)//only enable if wf is alive
 		{
 			Commands->Enable_Spawner(100732,true);
 			Commands->Enable_Spawner(100732,true);
Only in source/scripts: z_tropical.cpp
Only in source/scripts: z_tropical.h
diff -uwr sourceold/scripts/z_uberaow.cpp source/scripts/z_uberaow.cpp
--- sourceold/scripts/z_uberaow.cpp	2011-10-11 23:13:40.107421800 +0800
+++ source/scripts/z_uberaow.cpp	2012-04-28 01:56:21.067382800 +0800
@@ -88,7 +88,7 @@
 			{
 				if (Commands->Get_Player_Type(obj) == 0)
 				{
-					if (Commands->Get_Health(Find_Building(0,BuildingConstants::TYPE_REFINERY)) > 1.0f)
+					if (Find_Building_By_Type(0,BuildingConstants::TYPE_REFINERY) && Commands->Get_Health(Find_Building_By_Type(0,BuildingConstants::TYPE_REFINERY)) > 1.0f)
 					{
 						Commands->Give_Money(obj,500.0f,true);
 						Commands->Give_Points(Get_GameObj(plid),50.0f,false);
@@ -101,7 +101,7 @@
 				}
 				else if (Commands->Get_Player_Type(obj) == 1)
 				{
-					if (Commands->Get_Health(Find_Building(1,BuildingConstants::TYPE_REFINERY)) > 1.0f)
+					if (Find_Building_By_Type(1,BuildingConstants::TYPE_REFINERY) && Commands->Get_Health(Find_Building_By_Type(1,BuildingConstants::TYPE_REFINERY)) > 1.0f)
 					{
 						Commands->Give_Money(obj,500.0f,true);
 						Commands->Give_Points(Get_GameObj(plid),50.0f,false);
@@ -230,7 +230,7 @@
 
 void z_POW_ObiGun::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message	== 1000000025)
+	if (message	== CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Send_Message_Player(sender,104,234,40,"You lucky ass you got the Obelisk Weapon!");
 		Commands->Send_Custom_Event(obj,sender,1000,1,1);//start obi revoke timer
diff -uwr sourceold/scripts/z_zones.cpp source/scripts/z_zones.cpp
--- sourceold/scripts/z_zones.cpp	2011-10-11 23:14:32.120117100 +0800
+++ source/scripts/z_zones.cpp	2012-06-09 08:11:12.287109300 +0800
@@ -17,7 +17,7 @@
 #include "VehicleGameObjDef.h"
 #include "z_zones.h"
 #include "BaseControllerClass.h"
-
+#include "ScriptableGameObj.h"
 
 void z_Sell_Zone::Entered(GameObject *obj,GameObject *enterer)
 {
@@ -30,7 +30,7 @@
 	{
 		
 		int Player_Type = Get_Int_Parameter("Player_Type");
-		if (!Is_Building_Dead(Find_Building(Player_Type,BuildingConstants::TYPE_REPAIR_BAY)))
+		if (Find_Building_By_Type(Player_Type,BuildingConstants::TYPE_REPAIR_BAY) && !Is_Building_Dead(Find_Building_By_Type(Player_Type,BuildingConstants::TYPE_REPAIR_BAY)))
 		{
 			if (CheckPlayerType(enterer,Player_Type))
 			{
@@ -45,7 +45,7 @@
 			{
 				return;
 			}
-			if (Is_Vehicle(enterer))
+			if (enterer->As_VehicleGameObj())
 			{
 				Create_2D_Sound_Player(Get_Vehicle_Driver(enterer),Get_Parameter("Sound"));
 				InstallHook("Sell",Get_Vehicle_Driver(enterer));
@@ -78,7 +78,7 @@
 		RemoveHook();
 		ID = 0;
 	}
-	if (Is_Vehicle(Commands->Find_Object(ID)))
+	if (Commands->Find_Object(ID)->As_VehicleGameObj())
 	{
 		if (Get_Vehicle_Driver(Commands->Find_Object(ID)))
 		{
@@ -110,14 +110,14 @@
 
 void z_Aircraft_Refill::Entered(GameObject *obj, GameObject *enterer)
 {
-	if (!Is_Building_Dead(Find_Building(Get_Int_Parameter("TeamSelection"),BuildingConstants::TYPE_HELIPAD)))
+	if (Find_Building_By_Type(Get_Int_Parameter("TeamSelection"),BuildingConstants::TYPE_HELIPAD) && !Is_Building_Dead(Find_Building_By_Type(Get_Int_Parameter("TeamSelection"),BuildingConstants::TYPE_HELIPAD)))
 	{
 		if (Commands->Get_Player_Type(enterer) == Get_Int_Parameter("TeamSelection"))
 		{
 			if (!active)
 			{
 				GameObject *vobj = 0;
-				if (Is_Vehicle(enterer))
+				if (enterer->As_VehicleGameObj())
 				{
 					vobj = enterer;
 				}
@@ -148,12 +148,16 @@
 	Vector3 pos2;
 	float distance;
 	GameObject *object = Commands->Find_Object(number);
+	if (!object)
+	{
+		return;
+	}
 	pos1 = Commands->Get_Position(obj);
 	pos2 = Commands->Get_Position(object);
 	distance = Commands->Get_Distance(pos1,pos2);
 	if (distance <= 10.0)
 	{
-		if (Is_Vehicle(object))
+		if (object->As_VehicleGameObj())
 		{
 			if (Get_Vehicle_Mode(object) == VEHICLE_TYPE_FLYING && Get_Vehicle_Driver(object))
 			{
@@ -168,8 +172,8 @@
 void z_Repair_Zone_No_Boats::Entered(GameObject *obj,GameObject *enterer)
 {
 	int Player_Type = Get_Int_Parameter("Player_Type");
-	//if (!Is_Building_Dead(Find_Building(Get_Int_Parameter("TeamSelection"),BuildingConstants::TYPE_HELIPAD)))
-	if (!Is_Building_Dead(Find_Building_By_Name(Player_Type,"mp_Allied_Naval_Yard")))
+	//if (!Is_Building_Dead(Find_Building_By_Type(Get_Int_Parameter("TeamSelection"),BuildingConstants::TYPE_HELIPAD)))
+	if (Find_Building_By_Preset(Player_Type,"mp_Allied_Naval_Yard") && !Is_Building_Dead(Find_Building_By_Preset(Player_Type,"mp_Allied_Naval_Yard")))
 	{
 		if (CheckPlayerType(enterer,Player_Type))
 		{
@@ -184,7 +188,7 @@
 		{
 			return;
 		}
-		if (Is_Vehicle(enterer) && !Is_Script_Attached(enterer,"JFW_Boat"))
+		if (enterer->As_VehicleGameObj() && !Is_Script_Attached(enterer,"JFW_Boat"))
 		{
 			Create_2D_Sound_Player(Get_Vehicle_Driver(enterer),Get_Parameter("Sound"));
 			InstallHook("Repair",Get_Vehicle_Driver(enterer));
@@ -282,7 +286,7 @@
 
 void z_Helipad_Zone::Entered(GameObject *obj, GameObject *enterer)
 {
-	if (!Is_Building_Dead(Find_Building(Get_Int_Parameter("TeamSelection"),BuildingConstants::TYPE_HELIPAD)))
+	if (Find_Building_By_Type(Get_Int_Parameter("TeamSelection"),BuildingConstants::TYPE_HELIPAD) && !Is_Building_Dead(Find_Building_By_Type(Get_Int_Parameter("TeamSelection"),BuildingConstants::TYPE_HELIPAD)))
 	{
 		if (Commands->Get_Player_Type(enterer) == Get_Int_Parameter("TeamSelection"))
 		{
@@ -321,7 +325,7 @@
 {
 	if (Is_Script_Attached(enterer, "RA_Ore_Truck")) //Is this an Ore Truck?
 	{
-		if (!Is_Building_Dead(Find_Building(Get_Int_Parameter("Team"),BuildingConstants::TYPE_REFINERY)))
+		if (Find_Building_By_Type(Get_Int_Parameter("Team"),BuildingConstants::TYPE_REFINERY) && !Is_Building_Dead(Find_Building_By_Type(Get_Int_Parameter("Team"),BuildingConstants::TYPE_REFINERY)))
 		{
 			if (Commands->Get_Player_Type(enterer) == Get_Int_Parameter("Team")) //Is it a friendly truck?
 			{
@@ -348,7 +352,7 @@
 	{
 		return;
 	}
-	if (Is_Vehicle(enterer) && Is_Script_Attached(enterer,"JFW_Boat"))
+	if (enterer->As_VehicleGameObj() && Is_Script_Attached(enterer,"JFW_Boat"))
 	{
 		Create_2D_Sound_Player(Get_Vehicle_Driver(enterer),Get_Parameter("Sound"));
 		InstallHook("Repair",Get_Vehicle_Driver(enterer));
diff -uwr sourceold/swap/Swap.vcxproj source/swap/Swap.vcxproj
--- sourceold/swap/Swap.vcxproj	2011-11-26 13:18:00.907226500 +0800
+++ source/swap/Swap.vcxproj	2012-05-28 13:38:16.335554800 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
diff -uwr sourceold/tdbedit/Search.cpp source/tdbedit/Search.cpp
--- sourceold/tdbedit/Search.cpp	2011-10-11 23:02:47.273437500 +0800
+++ source/tdbedit/Search.cpp	2012-05-02 02:18:04.281250000 +0800
@@ -18,6 +18,9 @@
 #include "tdbedit.h"
 #include "resource.h"
 #include "search.h"
+#include "PresetMgr.h"
+#include "AudibleSoundDefinitionClass.h"
+#include "DefinitionMgrClass.h"
 
 HWND g_List = NULL;
 HWND g_Results = NULL;
@@ -369,6 +372,7 @@
 
 #pragma warning (disable : 4311 4312)
 
+extern bool presetloaded;
 void StoreInfo(HWND hDlg, TDBObjClass *obj)
 {
 	char temp[1000];
@@ -426,13 +430,33 @@
 		}
 	}
 	obj->Set_String(TranslateDBClass::Get_Current_Language(),newstr);
+	if (presetloaded)
+	{
+		char lBuf[256];
+		GetDlgItemTextA(hDlg, IDC_SOUND_ID, lBuf, 256);
+		DefinitionClass *definition = DefinitionMgrClass::Find_Named_Definition(lBuf,false);
+		if (definition)
+		{
+			obj->Set_Sound_ID(definition->Get_ID());
+		}
+		else
+		{
+			obj->Set_Sound_ID(0);
+		}
+	}
+	else
+	{
 	int snd = GetDlgItemInt(hDlg,IDC_SOUND_ID,&b,true);
 	if (b)
 	{
 		obj->Set_Sound_ID(snd);
 	}
+		else
+		{
+			obj->Set_Sound_ID(0);
+		}
+	}
 }
-
 void DoInfo(HWND hDlg, TDBObjClass *obj)
 {
 	unsigned long ID = obj->Get_Sound_ID();
@@ -477,8 +501,203 @@
 		}
 		SetDlgItemText(hDlg, IDC_TEXT, newstr);
 	}
+	if (presetloaded)
+	{
+		PresetClass *preset = PresetMgrClass::Find_Preset(ID);
+		if (preset && preset->Get_Definition() && preset->Get_Definition()->Get_Name())
+		{
+			SetDlgItemTextA(hDlg, IDC_SOUND_ID, preset->Get_Definition()->Get_Name());
+			EnableWindow(GetDlgItem(hDlg,IDC_SOUND_ID),false);
+		}
+	}
+	else
+	{
+		EnableWindow(GetDlgItem(hDlg,IDSOUND),false);
 	SetDlgItemInt(hDlg, IDC_SOUND_ID, ID, true);
 }
+}
+
+HTREEITEM TreeViewInsertItem(HWND tree,const char *text,HTREEITEM parent,HTREEITEM insertafter)
+{
+	TVINSERTSTRUCTA str;
+	str.hParent = parent;
+	str.hInsertAfter = insertafter;
+	str.item.mask = TVIF_TEXT;
+	str.item.pszText = (LPSTR)text;
+	return (HTREEITEM)SendMessage(tree,TVM_INSERTITEMA,0,(LPARAM)&str);
+}
+struct TreeItemData
+{
+	int type;
+	void *ptr;
+};
+void TreeViewSetData(HWND tree,HTREEITEM item,void *data,int type)
+{
+	TVITEM tv;
+	tv.mask = TVIF_PARAM;
+	tv.hItem = item;
+	SendMessage(tree,TVM_GETITEM,0,(LPARAM)&tv);
+	if (!tv.lParam)
+	{
+		TreeItemData *data2 = new TreeItemData;
+		data2->type = type;
+		data2->ptr = data;
+		tv.mask = TVIF_PARAM;
+		tv.hItem = item;
+		tv.lParam = (LPARAM)data2;
+		SendMessage(tree,TVM_SETITEM,0,(LPARAM)&tv);
+	}
+}
+
+void *TreeViewGetData(HWND tree,HTREEITEM item,int type)
+{
+	if (item)
+	{
+		TVITEM tv;
+		tv.mask = TVIF_PARAM;
+		tv.hItem = item;
+		SendMessage(tree,TVM_GETITEM,0,(LPARAM)&tv);
+		TreeItemData *data = (TreeItemData *)tv.lParam;
+		if (data != 0)
+		{
+			if (data->type == type)
+			{
+				return data->ptr;
+			}
+		}
+	}
+	return 0;
+}
+
+void Sort_Tree(HWND tree,HTREEITEM item)
+{
+	for (HTREEITEM i = (HTREEITEM)SendMessage(tree,TVM_GETNEXTITEM,TVGN_CHILD,(LPARAM)item);i;i = (HTREEITEM)SendMessage(tree,TVM_GETNEXTITEM,TVGN_NEXT,(LPARAM)i))
+	{
+		SendMessage(tree,TVM_SORTCHILDREN,0,(LPARAM)i);
+		TVITEM tv;
+		tv.mask = TVIF_CHILDREN;
+		tv.hItem = i;
+		SendMessage(tree,TVM_GETITEM,0,(LPARAM)&tv);
+		if (tv.cChildren)
+		{
+			Sort_Tree(tree,i);
+		}
+	}
+}
+HTREEITEM Selection;
+PresetClass *selpreset;
+void Populate_Children(HWND tree,HTREEITEM item,uint32 id)
+{
+	PresetClass *preset2 = PresetMgrClass::Find_Preset(id);
+	for (int i = 0;i < preset2->Get_Child_Count();i++)
+	{
+		PresetClass *preset = preset2->Get_Child(i);
+		const char *str = 0;
+		if (preset->Get_Definition())
+		{
+			str = preset->Get_Definition()->Get_Name();
+		}
+		HTREEITEM newitem = TreeViewInsertItem(tree,str,item,TVI_LAST);
+		if (newitem)
+		{
+			if (selpreset == preset)
+			{
+				Selection = newitem;
+			}
+			TreeViewSetData(tree,newitem,preset,1);
+			if (preset->Get_Definition())
+			{
+				preset->Set_Definition_ID(preset->Get_Definition()->Get_ID());
+			}
+			Populate_Children(tree,newitem,preset->Get_Definition_ID());
+		}
+	}
+}
+
+INT_PTR CALLBACK Dlg_Sound(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
+{
+	switch (uMsg)
+	{
+		case WM_INITDIALOG:
+			{
+				Selection = 0;
+				selpreset = (PresetClass *)lParam;
+				HWND tree = GetDlgItem(hDlg,IDC_TREE);
+				SendMessage(tree,WM_SETREDRAW,0,0);
+				SendMessage(tree,TVM_SELECTITEM,TVGN_CARET,0);
+				SendMessage(tree,TVM_DELETEITEM,0,(LPARAM)TVI_ROOT);
+				for (PresetClass *i = PresetMgrClass::Find_First_Preset(20480,1,true);i;i = PresetMgrClass::Find_Next_Preset(i,20480,1,true))
+				{
+					if (!i->Get_Parent() || i->Get_Definition()->Get_Class_ID() == 57344)
+					{
+						const char *str = 0;
+						if (i->Get_Definition())
+						{
+							str = i->Get_Definition()->Get_Name();
+						}
+						HTREEITEM newitem = TreeViewInsertItem(tree,str,TVI_ROOT,TVI_LAST);
+						if (newitem)
+						{
+							if (selpreset == i)
+							{
+								Selection = newitem;
+							}
+							TreeViewSetData(tree,newitem,i,1);
+							if (i->Get_Definition())
+							{
+								i->Set_Definition_ID(i->Get_Definition()->Get_ID());
+							}
+							Populate_Children(tree,newitem,i->Get_Definition_ID());
+						}
+					}
+				}
+				HTREEITEM none = TreeViewInsertItem(tree,"<None>",TVI_ROOT,TVI_FIRST);
+				SendMessage(tree,TVM_SORTCHILDREN,0,(LPARAM)TVI_ROOT);
+				Sort_Tree(tree,TVI_ROOT);
+				SendMessage(tree,WM_SETREDRAW,1,0);
+				if (Selection)
+				{
+					SendMessage(tree,TVM_ENSUREVISIBLE,0,(LPARAM)Selection);
+					SendMessage(tree,TVM_SELECTITEM,TVGN_CARET,(LPARAM)Selection);
+				}
+				else
+				{
+					SendMessage(tree,TVM_SELECTITEM,TVGN_CARET,(LPARAM)none);
+				}
+			}
+			return TRUE;
+			break;
+		case WM_CLOSE:
+			return EndDialog(hDlg, -1);
+			break;
+		case WM_COMMAND:
+			switch (LOWORD(wParam))
+			{
+			case IDCANCEL:
+				return EndDialog(hDlg, -1);
+			case IDOK:
+				{
+					HWND tree = GetDlgItem(hDlg,IDC_TREE);
+					HTREEITEM i = (HTREEITEM)SendMessage(tree,TVM_GETNEXTITEM,TVGN_CARET,0);
+					PresetClass *preset = (PresetClass *)TreeViewGetData(tree,i,1);
+					if (preset)
+					{
+						return EndDialog(hDlg, preset->Get_Definition_ID());
+					}
+					else
+					{
+						return EndDialog(hDlg, 0);
+					}
+				}
+			default:
+				break;
+			}
+			break;
+		default:
+			break;
+	}
+	return FALSE;
+}
 
 TDBObjClass *obj;
 INT_PTR CALLBACK Dlg_Info(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
@@ -504,6 +723,31 @@
 				StoreInfo(hDlg, obj);
 				SetFocus(g_List);
 				return EndDialog(hDlg, 1);
+			case IDSOUND:
+				{
+					char lBuf[256];
+					GetDlgItemTextA(hDlg, IDC_SOUND_ID, lBuf, 256);
+					DefinitionClass *definition = DefinitionMgrClass::Find_Named_Definition(lBuf,false);
+					PresetClass *preset = 0;
+					if (definition)
+					{
+						preset = PresetMgrClass::Find_Preset(definition->Get_ID());
+					}
+					int ID = DialogBoxParam(g_hInstance, (LPWSTR)IDD_SOUNDLIST, hDlg, Dlg_Sound,(LPARAM)preset);
+					if (ID != -1)
+					{
+						PresetClass *preset = PresetMgrClass::Find_Preset(ID);
+						if (preset && preset->Get_Definition() && preset->Get_Definition()->Get_Name())
+						{
+							SetDlgItemTextA(hDlg, IDC_SOUND_ID, preset->Get_Definition()->Get_Name());
+						}
+						else
+						{
+							SetDlgItemTextA(hDlg, IDC_SOUND_ID, "");
+						}
+					}
+				}
+				return TRUE;
 			default:
 				break;
 			}
@@ -515,7 +759,6 @@
 }
 
 #pragma warning (default : 4311 4312)
-
 int TDBEdit(TDBObjClass *obj2)
 {
 	int i = DialogBoxParam(g_hInstance, (LPWSTR)IDD_Info, g_MainWnd, Dlg_Info, (LPARAM)obj2);
diff -uwr sourceold/tdbedit/resource.h source/tdbedit/resource.h
--- sourceold/tdbedit/resource.h	2009-12-25 08:41:14.202307800 +0800
+++ source/tdbedit/resource.h	2012-05-01 23:29:40.621093700 +0800
@@ -2,6 +2,7 @@
 // Microsoft Visual C++ generated include file.
 // Used by tdbedit.rc
 //
+#define IDSOUND                         3
 #define IDR_MAIN                        101
 #define IDD_Goto                        102
 #define IDD_Find_ID                     103
@@ -11,6 +12,7 @@
 #define IDD_Info                        107
 #define IDD_New_Category                108
 #define IDI_MAIN                        110
+#define IDD_SOUNDLIST                   111
 #define IDC_TEXT                        1001
 #define IDC_GOTO_INT                    1004
 #define IDC_FIND_STRING                 1005
@@ -27,6 +29,7 @@
 #define IDC_ENG_STRING                  1015
 #define IDC_CATEGORY                    1015
 #define IDC_ID_N                        1016
+#define IDC_TREE                        1183
 #define ID_NEW                          40020
 #define ID_OPEN                         40021
 #define ID_SAVE                         40023
@@ -50,14 +53,16 @@
 #define ID_REMOVECATEGORY               40054
 #define ID_EXPORT_TABLE                 40055
 #define ID_IMPORT_TABLE                 40056
+#define ID_FILE_OPENDDB                 40057
+#define ID_OPEN_DDB                     40058
 #define IDC_STATIC                      -1
 
 // Next default values for new objects
 // 
 #ifdef APSTUDIO_INVOKED
 #ifndef APSTUDIO_READONLY_SYMBOLS
-#define _APS_NEXT_RESOURCE_VALUE        111
-#define _APS_NEXT_COMMAND_VALUE         40057
+#define _APS_NEXT_RESOURCE_VALUE        112
+#define _APS_NEXT_COMMAND_VALUE         40059
 #define _APS_NEXT_CONTROL_VALUE         1016
 #define _APS_NEXT_SYMED_VALUE           101
 #endif
